=== src/dos/Makefile ===
# For GNU Make.  Just for cleaning purposes.

.PHONY:	clean

clean:
	rm -f frotz.exe FROTZ.EXE
	rm -f *.O *.o
