=== debian/changelog ===
frotz (2.54+dfsg-4) unstable; urgency=medium

  * GCC 14 catches a few more uint32_t / ulong mix-ups, expand
    uint32.patch to include them. Closes: #1074870.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 04 Jul 2024 13:38:52 +0200

frotz (2.54+dfsg-3) unstable; urgency=medium

  * Build-depend on libfreetype-dev instead of libfreetype6-dev, and
    libncurses-dev instead of libncurses5-dev.
  * Standards-Version 4.6.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 29 Jan 2023 15:19:56 +0100

frotz (2.54+dfsg-2) unstable; urgency=medium

  [ Stephen Kitt ]
  * Add mailcap entries. Closes: #381231.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Stephen Kitt <skitt@debian.org>  Mon, 12 Dec 2022 22:59:32 +0100

frotz (2.54+dfsg-1) unstable; urgency=medium

  * New upstream release, merging spelling-fixes.patch.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 16 Apr 2022 10:17:25 +0200
