## frotz 2.55+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 # Makefile for Unix Frotz
 # GNU make is required.
 
-# Your C compiler
-#CC ?= gcc
-#CC ?= clang
+# Choose your preferred C compiler
+#CC = gcc
+#CC = clang
 
 # Enable compiler warnings. This is an absolute minimum.
 CFLAGS += -Wall -std=c99 -O3 #-Wextra
@@ -67,11 +67,11 @@
 #CURSES ?= ncurses
 CURSES ?= ncursesw
 
-# This Makefile uses the pkg-config utility to get information on
+# This Makefile uses the pkgconf utility to get information on
 # installed libraries.  If your system is missing that utility and
-# cannot install it for whatever reason (usually very old ones), you
+# cannot install it for whatever reason (usually very old systems), you
 # will need to uncomment and perhaps modify some of these lines.
-# I don't see any way around not having pkg-config for SDL.
+# I don't see any way around not having pkgconf for SDL.
 #CURSES_LDLAGS += -l$(CURSES) -ltinfo
 #CURSES_CFLAGS += -D_DEFAULT_SOURCE -D_XOPEN_SOURCE=600
 
@@ -80,6 +80,10 @@
 # Doing this for the X11 interface will make it use old-style graphics.
 #NO_BLORB = yes
 
+
+################################
+# Potentially Missing Functions
+#
 # These are for enabling local version of certain functions which may be
 # missing or behave differently from what's expected in modern system.
 # If you're running on a system made in the past 20 years, you should be
@@ -91,17 +95,20 @@
 # For missing memmove()
 #NO_MEMMOVE = yes
 
-# For missing strdup() and strndup()
+# For missing strdup()
 #NO_STRDUP = yes
+
+# For missing strndup()
+#NO_STRNDUP = yes
 
 # For missing strrchr()
 #NO_STRRCHR = yes
 
+# For missing basename()
+#NO_BASENAME = yes
+
 # Uncomment to disable format codes for dumb interface
 #DISABLE_FORMATS = yes
-
-# For missing basename()
-#NO_BASENAME = yes
 
 # If your target complains excessively about unused parameters, uncomment this
 #SILENCE_UNUSED = yes
@@ -113,6 +120,20 @@
 INPUT_BUFFER_SIZE = 200
 STACK_SIZE = 1024
 
+# If SDL2 is available, you most certainly will/should have pkgconf
+# available, but if not, these defaults should work;
+SDL_CFLAGS_DEF = -I/usr/include/libpng16 -I/usr/include/SDL2 \
+	-D_REENTRANT -I/usr/include/freetype2
+SDL_SOUND_CFLAGS_DEF = -I/usr/include/glib-2.0 -I/usr/include/opus \
+	-I/usr/include/dbus-1.0 -I/usr/include/libinstpatch-2 -pthread \
+	-D_REENTRANT -D_DEFAULT_SOURCE -D_XOPEN_SOURCE=600
+SDL_LDFLAGS_DEF = -lm -lpng16 -ljpeg -lSDL2 -lfreetype -lz
+SDL_SOUND_LDFLAGS_DEF = -lSDL2_mixer
+
+# Here are some reasonable defaults for the the X11 interface.
+X11_CFLAGS_DEF = -I/usr/include/libpng16
+X11_LDFLAGS_DEF = -lXt -lX11 -lpng16 -ljpeg -lz -lm
+
 
 #########################################################################
 # This section is where Frotz is actually built.
@@ -143,24 +164,55 @@
 ifeq ($(MAKECMDGOALS),dosdefs)
     EXPORT_TYPE = dos
 endif
+ifeq ($(MAKECMDGOALS),simple)
+    EXPORT_TYPE = simple
+endif
 
 RANLIB ?= ranlib
-PKG_CONFIG ?= pkg-config
-
-# If we have pkg-config...
-ifneq ($(shell which $(PKG_CONFIG)),)
-# if pkg-config has $(CURSES)
-ifeq ($(shell $(PKG_CONFIG) --exists $(CURSES) && echo 0),0)
-# use pkg-config $(CURSES) info
-PKG_CONFIG_CURSES = yes
-CURSES_LDFLAGS += $(shell $(PKG_CONFIG) $(CURSES) --libs)
-CURSES_CFLAGS += $(shell $(PKG_CONFIG) $(CURSES) --cflags)
+
+# Check to see if pkgconf or pkg-config is available.
+# Both are functionally identical with the name pkg-config being deprecated.
+PKGCONF_BIN ?= pkgconf
+PKG_CONFIG_BIN ?= pkg-config
+# If we don't have pkgconf", check if pkg-config is available.
+ifneq ($(shell which $(PKGCONF_BIN)),)
+PKGCONF = $(PKGCONF_BIN)
+else
+$(warning *** Could not find $(PKGCONF_BIN).  Is $(PKG_CONFIG_BIN) available?)
+# Check if pkg-config is available.
+ifneq ($(shell which $(PKG_CONFIG_BIN)),)
+$(warning *** Found $(PKG_CONFIG_BIN)!  Now proceeding normally.)
+PKGCONF = $(PKG_CONFIG_BIN)
+else
+# Neither pkgconf nor pkg-config found.
+$(warning *** Neither $(PKGCONF_BIN) nor $(PKG_CONFIG_BIN) are found!)
+$(warning *** Trying default configuration settings.  If these don't work,)
+$(warning *** check the configuration section of the main Makefile.)
+NO_PKGCONF = yes
+endif
+endif
+
+
+#######################
+# Curses configuration.
+ifeq ($(NO_PKGCONF), yes)
+CURSES_LDFLAGS += -l$(CURSES)
+CURSES_CFLAGS += -D_DEFAULT_SOURCE
+else
+# if pkgconf has $(CURSES)
+ifeq ($(shell $(PKGCONF) --exists $(CURSES) && echo 0),0)
+# use pkgconf $(CURSES) info
+PKGCONF_CURSES = yes
+CURSES_LDFLAGS += $(shell $(PKGCONF) $(CURSES) --libs)
+CURSES_CFLAGS += $(shell $(PKGCONF) $(CURSES) --cflags)
 else # Otherwise, try something obvious like before.
 CURSES_LDFLAGS += -l$(CURSES)
-endif
-endif
-
-
+CURSES_CFLAGS += -D_DEFAULT_SOURCE
+endif
+endif
+
+
+#############################
 # OS-specific configurations.
 # NetBSD
 ifeq ($(UNAME_S),NetBSD)
@@ -231,8 +283,8 @@
 CURSES_DEFINE = USE_NCURSES_H
 endif
 
-MKFONTDIR ?= $(shell which mkfontdir)
-
+
+# Export variables to sub-Makefiles.
 export CC
 export CFLAGS
 export CURSES_CFLAGS
@@ -241,28 +293,53 @@
 export AR
 export RANLIB
 export SYSCONFDIR
-export SDL_CFLAGS
 export COLOR
 export ITALIC
 export SOUND_TYPE
 export NO_SOUND
+export DESTDIR
+export PREFIX
+export PKGCONF
+export NO_PKGCONF
+
+export CURSES_DEFINE
+export SAMPLERATE
+export BUFFSIZE
+export DEFAULT_CONVERTER
+export USE_UTF8
+
+export SDL_PKGS
+export SDL_SOUND_PKGS
+export SDL_CFLAGS
+export SDL_LDFLAGS
+export SDL_SOUND_CFLAGS
+export SDL_SOUND_LDFLAGS
+export SDL_CFLAGS_DEF
+export SDL_SOUND_CFLAGS_DEF
+export SDL_LDFLAGS_DEF
+export SDL_SOUND_LDFLAGS_DEF
+
+export X11_PKGS
+export X11_CFLAGS
+export X11_CFLAGS_DEF
 
 NAME = frotz
-VERSION = 2.54
+VERSION = 2.55
 RELEASE_NOTES = "Official release."
-
-# If we're working from git, we have access to proper variables. If
-# not, make it clear that we're working from a release.
+#RELEASE_NOTES = "Development release."
+
+# If we're working from git, we have access to proper variables.
+# If not, make it clear that we're working from a release.
 #
 GIT_DIR ?= .git
 ifneq ($(and $(wildcard $(GIT_DIR)),$(shell which git)),)
 GIT_HASH = $(shell git rev-parse HEAD)
-GIT_HASH_SHORT = $(shell git rev-parse --short HEAD)
+GIT_HASH_SHORT = $(shell git rev-parse --short=8 HEAD)
 GIT_DATE = $(shell git show -s --format=%ci)
 else
-GIT_HASH = 5a86de2f0799bde12699a0189ea12be8c96194a5
-GIT_HASH_SHORT = 5a86de2
-GIT_DATE = 2022-04-13 23:47:41 -0700
+GIT_HASH = acf205585a9472d27c07c0fe62da4b8bc89d1ec7
+GIT_HASH_SHORT = acf20558
+GIT_DATE = 2025-02-01 14:36:37 -0800
 endif
 export CFLAGS
 
@@ -276,13 +353,13 @@
 HASH = $(COMMON_DIR)/hash.h
 
 MISC_DIR = $(SRCDIR)/misc
+FONTS_DIR = fonts
 
 BLORB_DIR = $(SRCDIR)/blorb
 BLORB_LIB = $(BLORB_DIR)/blorblib.a
 
 CURSES_DIR = $(SRCDIR)/curses
 CURSES_LIB = $(CURSES_DIR)/frotz_curses.a
-CURSES_DEFINES = $(CURSES_DIR)/ux_defines.h
 
 DUMB_DIR = $(SRCDIR)/dumb
 DUMB_LIB = $(DUMB_DIR)/frotz_dumb.a
@@ -291,16 +368,15 @@
 
 X11_DIR = $(SRCDIR)/x11
 X11_LIB = $(X11_DIR)/frotz_x11.a
-export X11_PKGS = x11 xt libpng libjpeg zlib
-X11_FONTDIR = $(DESTDIR)$(PREFIX)/share/fonts/X11/zork
-X11_LDFLAGS = `pkg-config $(X11_PKGS) --libs` -lm
+X11_PKGS = x11 xt libpng libjpeg zlib
 
 SDL_DIR = $(SRCDIR)/sdl
 SDL_LIB = $(SDL_DIR)/frotz_sdl.a
-export SDL_PKGS = libpng libjpeg sdl2 SDL2_mixer freetype2 zlib
-SDL_LDFLAGS += $(shell $(PKG_CONFIG) $(SDL_PKGS) --libs) -lm
-
-SUBDIRS = $(COMMON_DIR) $(CURSES_DIR) $(X11_DIR) $(SDL_DIR) $(DUMB_DIR) $(BLORB_DIR) $(DOS_DIR)
+SDL_PKGS = libpng libjpeg sdl2 freetype2 zlib
+SDL_SOUND_PKGS = SDL2_mixer
+SDL_LDFLAGS += -lm
+
+SUBDIRS = $(COMMON_DIR) $(CURSES_DIR) $(X11_DIR) $(SDL_DIR) $(DUMB_DIR) $(BLORB_DIR) $(DOS_DIR) $(FONTS_DIR)
 SUB_CLEAN = $(SUBDIRS:%=%-clean)
 
 FROTZ_BIN = frotz$(EXTENSION)
@@ -351,7 +427,7 @@
 curses: $(FROTZ_BIN)
 ncurses: $(FROTZ_BIN)
 $(FROTZ_BIN): $(FROTZ_LIBS)
-	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(CURSES_LDFLAGS) $(CURSES_SOUND_LDFLAGS)
+	$(CC) $+ -o $@ $(LDFLAGS) $(CURSES_LDFLAGS) $(CURSES_SOUND_LDFLAGS)
 	@echo "** Done building Frotz with curses interface"
 	@echo "** Audio support $(CURSES_SOUND) (type $(SOUND_TYPE))"
 	@echo "** Blorb support $(BLORB_SUPPORT)"
@@ -359,67 +435,4 @@
 nosound: nosound_helper $(FROTZ_BIN) | nosound_helper
 nosound_helper:
 	$(eval SOUND_TYPE= none)
-	$(eval NO_SOUND= -DNO_SOUND)
 	$(eval CURSES_SOUND_LDFLAGS= )
-	$(eval CURSES_SOUND= disabled)
-
-dumb: $(DFROTZ_BIN)
-$(DFROTZ_BIN): $(DFROTZ_LIBS)
-	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS)
-	@echo "** Done building Frotz with dumb interface."
-	@echo "** Blorb support $(BLORB_SUPPORT)"
-
-x11: $(XFROTZ_BIN)
-$(XFROTZ_BIN): $(XFROTZ_LIBS)
-	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(X11_LDFLAGS)
-	@echo "** Done building Frotz with X11 interface."
-
-sdl: $(SFROTZ_BIN)
-$(SFROTZ_BIN): $(SFROTZ_LIBS)
-	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(SDL_LDFLAGS)
-	@echo "** Done building Frotz with SDL interface."
-
-owdos: $(DOS_BIN)
-$(DOS_BIN): $(COMMON_DEFINES) $(HASH)
-ifneq ($(shell which wmake),)
-	wmake -f Makefile.ow
-else
-	$(error wmake command not found.  Cannot make the DOS version)
-endif
-
-all: $(FROTZ_BIN) $(DFROTZ_BIN) $(SFROTZ_BIN) $(XFROTZ_BIN)
-snavig:
-	@echo "Snavig: Change an object's shape..."
-	@echo "Possible snavig-processed targets:"
-	@echo "  dos    (done)"
-	@echo "  tops20 (done)"
-	@echo "  its    (not even started)"
-	@echo "  tops10 (not even started)"
-	@echo "  tenex  (not even started)"
-	@echo "  waits  (not even started)"
-	@echo "That's all for now."
-
-dos: $(COMMON_DEFINES) $(HASH)
-	@rm -rf $(SNAVIG_DIR)
-	@mkdir $(SNAVIG_DIR)
-	@echo "** Copying support text files to $(SNAVIG_DIR)"
-	@cp Makefile.tc Makefile.ow $(SNAVIG_DIR)
-	@cp owbuild.bat tcbuild.bat $(SNAVIG_DIR)
-	@cp INSTALL_DOS $(SNAVIG_DIR)/INSTALL.txt
-	@cp doc/frotz.txt $(SNAVIG_DIR)
-	@sed -i "/^OW_DOS_DIR.*/d" $(SNAVIG_DIR)/Makefile.ow
-	@sed -i "/^CORE_DIR.*/d" $(SNAVIG_DIR)/Makefile.ow
-	@sed -i "/^BLORB_DIR.*/d" $(SNAVIG_DIR)/Makefile.ow
-	@echo "** Invoking snavig"
-	@$(SNAVIG) -t dos $(COMMON_DIR) $(BLORB_DIR) $(DOS_DIR) $(SNAVIG_DIR)
-	@echo "** Adding frotz.prj for building with Turbo C IDE"
-	@cp frotz.prj $(SNAVIG_DIR)
-	@echo "$(SNAVIG_DIR)/ now contains Frotz source code for 16-bit DOS."
-	@echo "Supported compilers are:"
-	@echo "  Borland Turbo C 3.00 and Borland MAKE 3.6"
-	@echo "  Open Watcom C 2.0 and Open Watcom MAKE (wmake)"
-
-tops20: $(COMMON_DEFINES) $(HASH)
-	@rm -rf $(SNAVIG_DIR)
-	@mkdir $(SNAVIG_DIR)
-	@echo "** Invoking snavig"
