=== debian/changelog ===
frotz (2.55+dfsg-3) unstable; urgency=medium

  * Use int throughout instead of the custom bool (which is int), to avoid
    conflicting with C23’s bool. Closes: #1096660.
  * Remove the old FSF address from debian/copyright.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 07 Sep 2025 22:35:55 +0200

frotz (2.55+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS:
    + Adapt to upstream rename PKG_CONFIG -> PKGCONF_BIN.
    + cross.patch: Remove ux_defines.h from .PHONY to avoid rebuilding during
      make install.
    Closes: #1095250.

 -- Stephen Kitt <skitt@debian.org>  Fri, 07 Feb 2025 07:46:03 +0100

frotz (2.55+dfsg-1) unstable; urgency=medium

  * New upstream release, obsoleting uint32.patch.
  * Update debian/watch to handle recent GitLab changes. Thanks to
    Patrice Duroux for the patch! Closes: #1090045.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Feb 2025 07:35:10 +0100
