=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libsndfile1-dev,
  libvorbis-dev,
  zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/games-team/frotz
 Vcs-Git: https://salsa.debian.org/games-team/frotz.git
 Rules-Requires-Root: no
