=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- BINDIR=/usr/games CFLAGS="$(CPPFLAGS) $(CFLAGS)" curses dumb sdl PKGCONF_BIN='$(PKG_CONFIG)'

override_dh_auto_install:
	dh_auto_install -- BINDIR=/usr/games PREFIX=/usr install_frotz install_dfrotz install_sfrotz
