=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg,searchmode=plain" \
  https://gitlab.com/DavidGriffith/frotz/tags?sort=updated_desc \
  -/archive/[^/]+/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
